/* Popup Menu Example */

#include <Xm/Xm.h>
#include <Xm/LabelG.h>
#include <Xm/PushBG.h>
#include <Xm/CascadeBG.h>
#include <Xm/SeparatoG.h>
#include <Xm/RowColumn.h>


/*********** Callback for the Pushbuttons ***********************/

void ButtonCB (w, client_data, call_data) 
Widget	w;			/*  widget id		*/
caddr_t	client_data;		/*  data from application   */
caddr_t	call_data;		/*  data from widget class  */
{
   /*  print message and terminate program  */
   printf ("Button %s selected.\n", client_data);
	
}

/************** Event Handler for Popup Menu ************************/

PostIt (w, popup, event)
Widget w;
Widget popup;
XButtonEvent * event;
{
   if (event->button != Button3)
	return;
   XmMenuPosition(popup, event);
   XtManageChild(popup);
}

/***********************Main Logic for Program ********************/


void main (argc, argv)
int argc;
char **argv;
{
   Widget toplevel, popup, rc;
   Widget buttons[2], popupBtn[5];
   Arg args[5];
   XmString string;

/* Initialize toolkit */
   
   toplevel = XtInitialize (argv[0], "PopupMenu", NULL, 0, &argc, argv);

/* Create RowColumn in toplevel with two PushButtonGadgets */

   XtSetArg(args[0], XmNwidth, 150);
   XtSetArg(args[1], XmNheight, 125);
   XtSetArg(args[2], XmNresizeWidth, False);
   XtSetArg(args[3], XmNresizeHeight, False);
   XtSetArg(args[4], XmNadjustLast, False);
   rc = XmCreateRowColumn(toplevel, "rc", args, 5);  
   XtManageChild(rc);

   buttons[0] = XmCreatePushButtonGadget (rc, "buttonA", NULL, 0);
   XtAddCallback(buttons[0], XmNactivateCallback, (XtCallbackProc)ButtonCB, (XtPointer)"A");

   buttons[1] = XmCreatePushButtonGadget (rc, "buttonB", NULL, 0);
   XtAddCallback(buttons[1], XmNactivateCallback, (XtCallbackProc)ButtonCB, (XtPointer)"B");

   XtManageChildren (buttons, 2);

/* Create popup menu with accelerator CTRL P */
   
   XtSetArg(args[0], XmNmenuAccelerator, "Ctrl <Key> p");
   popup = XmCreatePopupMenu(rc, "popup", args, 1);
   XtAddEventHandler(rc, ButtonPressMask, False, (XtEventHandler)PostIt, (XtPointer)popup);


/* Create title for the popup menu and a separator */
   
#if 1
   string = XmStringCreate("Menu Title", XmSTRING_DEFAULT_CHARSET); 
   XtSetArg(args[0], XmNlabelString, string);
   popupBtn[0] = XmCreateLabelGadget(popup, "Title", args, 1);
   XmStringFree(string);   

   popupBtn[1] = XmCreateSeparatorGadget(popup, "separator", NULL, 0);

/* Create three PushButtonGadgets in the popup menu */

   XtSetArg(args[0], XmNmnemonic, '1'); 
   popupBtn[2] = XmCreatePushButtonGadget(popup, "button1", args, 1); 
   XtAddCallback(popupBtn[2], XmNactivateCallback, (XtCallbackProc)ButtonCB, (XtPointer)"1");

   XtSetArg(args[0], XmNmnemonic, '2'); 
   popupBtn[3] = XmCreatePushButtonGadget(popup, "button2", args, 1);
   XtAddCallback(popupBtn[3], XmNactivateCallback, (XtCallbackProc)ButtonCB, (XtPointer)"2");

   XtSetArg(args[0], XmNmnemonic, '3');
   popupBtn[4] = XmCreatePushButtonGadget (popup, "button3", args, 1); 
   XtAddCallback (popupBtn[4], XmNactivateCallback, (XtCallbackProc)ButtonCB, (XtPointer)"3");

   XtManageChildren (popupBtn, 5);
#else
   XtSetArg(args[0], XmNmnemonic, '3');
   popupBtn[0] = XmCreatePushButtonGadget (popup, "OPtions", args, 1); 
   XtAddCallback (popupBtn[0], XmNactivateCallback, (XtCallbackProc)ButtonCB, (XtPointer)"3");

   XtManageChildren (popupBtn, 1);
#endif

/* Get and dispatch events */

   XtRealizeWidget(toplevel);

   XtMainLoop();
}









